#ifndef HEADER_ENGINE
#define HEADER_ENGINE

#include "../C-Engine/CEngine/Object.hpp"
#include "../C-Engine/CEngine/Script.hpp"

#include "../C-Engine/CPhysics/Transforms.hpp"
#include "../C-Engine/CPhysics/Rigibodys.hpp"

#include "../C-Engine/CRendering/Render.hpp"
#include "../C-Engine/CRendering/Animation.hpp"
#include "../C-Engine/CRendering/Sprite.hpp"
#include "../C-Engine/CRendering/TilesMapping.hpp"

extern "C"
{
#include <fxlib.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "../C-Engine/CExtraLib/MonochromeLib.h"
#include "../C-Engine/CExtraLib/FonctionC.h"
}

class Engine
{
    public:

    Engine();

    //Fonction du Moteur

    int Game();
    void StopGame();
    void ShowFps();
    void HideFps();

    void MoveScreen( int x ,int y);
    void MiddleScreen(int x , int y , bool fixe = true);

    void AddObject( Object * v);
    void DelObject( Object * v);
    void DelAllObject();

    void AffectScript(Script & VScript);
    void AffectMap(Map * VMap);

    //Accesseur

    Object ** GetListeObject();
    Script * GetScript();
    AABB * GetScreen();
    Map * GetMap();
    int GetNbObject();
    int GetType();

    void SetFpsWish(int v);
    void SetType(int v);

    private:

    void UpdateRelativePosition();
    bool WaitOneSecond();

    Object ** ListeObject; // Tableau de pointeur sur Object
    Script * EScript;
    AABB screen;
    Map * gamemap;
    int nbobject;

    int time;
    bool run;
    bool execute;
    bool fps;
    int fpswish;
    bool restart;
    int type;

};

#endif

