#include "../C-Engine/CEngine/Object.hpp"
#include "../C-Engine/CEngine/Engine.hpp"
#include "../C-Engine/CEngine/Script.hpp"

#include "../C-Engine/CPhysics/Transforms.hpp"
#include "../C-Engine/CPhysics/Rigibodys.hpp"

#include "../C-Engine/CRendering/Render.hpp"
#include "../C-Engine/CRendering/Animation.hpp"
#include "../C-Engine/CRendering/Sprite.hpp"
#include "../C-Engine/CRendering/TilesMapping.hpp"

extern "C"
{
#include <fxlib.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "../C-Engine/CExtraLib/input.h"
#include "../C-Engine/CExtraLib/MonochromeLib.h"
#include "../C-Engine/CExtraLib/FonctionC.h"
}


Object::Object()
{
    OTransforms = new Transforms(this);
    ORender = new Render(this);
    ORigibody = NULL;
    OScript = NULL;
    Conteneur = NULL;
    enable = true;
    tag = new char[10];
}

Object::~Object()
{
    delete OTransforms;
    delete ORender;
    delete ORigibody;
    delete OScript;
    delete []tag;
}

void Object::AffectScript(Script * VScript)
{
    OScript = VScript;
    if(OScript != NULL)OScript->AffectObject(this);
}

 void Object::AffectEngine(Engine * EV)
 {
     Conteneur = EV;
 }

void Object::AddRigibody()
{
    ORigibody = new Rigibody(this);
}

Engine * Object::GetEngine()
{
    return Conteneur;
}

void Object::AffectTag(char * v)
 {
    strcpy(tag , v);
 }

void Object::Enable()
{
    this->enable = true;
}

void Object::Disable()
{
    this->enable = false;
}

bool Object::GetEnable()
{
    return this->enable;
}

bool Object::IsOnScreen()
{
    if(OTransforms->GetX() < Conteneur->GetScreen()->max.x && OTransforms->GetX() + ORender->GetSizeX() > Conteneur->GetScreen()->min.x && OTransforms->GetY() < Conteneur->GetScreen()->max.y && OTransforms->GetY() + ORender->GetSizeY()  > Conteneur->GetScreen()->min.y ) return true;
    else return false;
}

Object *  Object::CollisionTagO(char* v)
{
    int widht1 , height1;
    int widht2 , height2;

    for(int i = 0; i< Conteneur->GetNbObject(); i++)
    {
        if(strcmp(Conteneur->GetListeObject()[i]->tag , v) == 0 && Conteneur->GetListeObject()[i]->enable == true)
        {
            widht1 = 0; height1 = 0;
            widht2 = 0; height2 = 0;

           if(ORigibody != NULL)
           {
                if(ORigibody->GetStat() == true)
                     {widht1 = ORigibody->GetWidht(); height1 = ORigibody->GetHeight();}
                else {widht1 = ORender->GetSizeX(); height1 = ORender->GetSizeY();}
           }    else {widht1 = ORender->GetSizeX(); height1 = ORender->GetSizeY();}

           if(Conteneur->GetListeObject()[i]->ORigibody != NULL)
           {
                if(Conteneur->GetListeObject()[i]->ORigibody->GetStat() == true)
                     {widht2 = Conteneur->GetListeObject()[i]->ORigibody->GetWidht(); height2 = Conteneur->GetListeObject()[i]->ORigibody->GetHeight();}
                else {widht2 = Conteneur->GetListeObject()[i]->ORender->GetSizeX(); height2 = Conteneur->GetListeObject()[i]->ORender->GetSizeY();}
           }    else {widht2 = Conteneur->GetListeObject()[i]->ORender->GetSizeX(); height2 = Conteneur->GetListeObject()[i]->ORender->GetSizeY();}

           if( ((   Conteneur->GetListeObject()[i]->OTransforms->GetX()  + Conteneur->GetListeObject()[i]->ORender->GetBlitX() >= OTransforms->GetX() + ORender->GetBlitX() + widht1)
                 || (Conteneur->GetListeObject()[i]->OTransforms->GetX() + Conteneur->GetListeObject()[i]->ORender->GetBlitX() + widht2 <= OTransforms->GetX() + ORender->GetBlitX())
                 || (Conteneur->GetListeObject()[i]->OTransforms->GetY() + Conteneur->GetListeObject()[i]->ORender->GetBlitY()>= OTransforms->GetY()  + ORender->GetBlitY() + height1)
                 || (Conteneur->GetListeObject()[i]->OTransforms->GetY() + Conteneur->GetListeObject()[i]->ORender->GetBlitY() + height2 <= OTransforms->GetY() + ORender->GetBlitY())
                ) == false )
            {
            return Conteneur->GetListeObject()[i];
            }
        }
    }

return NULL;
}


bool Object::CollisionTag(char* v)
{

    int widht1 , height1;
    int widht2 , height2;

    for(int i = 0; i< Conteneur->GetNbObject(); i++)
    {
        if(strcmp(Conteneur->GetListeObject()[i]->tag , v) == 0 && Conteneur->GetListeObject()[i]->enable == true)
        {
            widht1 = 0; height1 = 0;
            widht2 = 0; height2 = 0;

           if(ORigibody != NULL)
           {
                if(ORigibody->GetStat() == true)
                     {widht1 = ORigibody->GetWidht(); height1 = ORigibody->GetHeight();}
                else {widht1 = ORender->GetSizeX(); height1 = ORender->GetSizeY();}
           }    else {widht1 = ORender->GetSizeX(); height1 = ORender->GetSizeY();}

           if(Conteneur->GetListeObject()[i]->ORigibody != NULL)
           {
                if(Conteneur->GetListeObject()[i]->ORigibody->GetStat() == true)
                     {widht2 = Conteneur->GetListeObject()[i]->ORigibody->GetWidht(); height2 = Conteneur->GetListeObject()[i]->ORigibody->GetHeight();}
                else {widht2 = Conteneur->GetListeObject()[i]->ORender->GetSizeX(); height2 = Conteneur->GetListeObject()[i]->ORender->GetSizeY();}
           }    else {widht2 = Conteneur->GetListeObject()[i]->ORender->GetSizeX(); height2 = Conteneur->GetListeObject()[i]->ORender->GetSizeY();}

           if( ((   Conteneur->GetListeObject()[i]->OTransforms->GetX()  + Conteneur->GetListeObject()[i]->ORender->GetBlitX() >= OTransforms->GetX() + ORender->GetBlitX() + widht1)
                 || (Conteneur->GetListeObject()[i]->OTransforms->GetX() + Conteneur->GetListeObject()[i]->ORender->GetBlitX() + widht2 <= OTransforms->GetX() + ORender->GetBlitX())
                 || (Conteneur->GetListeObject()[i]->OTransforms->GetY() + Conteneur->GetListeObject()[i]->ORender->GetBlitY()>= OTransforms->GetY()  + ORender->GetBlitY() + height1)
                 || (Conteneur->GetListeObject()[i]->OTransforms->GetY() + Conteneur->GetListeObject()[i]->ORender->GetBlitY() + height2 <= OTransforms->GetY() + ORender->GetBlitY())
                ) == false )
            {
            return true;
            }
        }
    }

return false;
}


Render * Object::GetRender()
{
    return ORender;
}

Transforms * Object::GetTransforms()
{
    return OTransforms;
}

Rigibody * Object::GetRigibody()
{
    return ORigibody;
}

Script * Object::GetScript()
{
    return OScript;
}
