#ifndef HEADER_OBJECT
#define HEADER_OBJECT

#include "../C-Engine/CEngine/Engine.hpp"
#include "../C-Engine/CEngine/Script.hpp"

#include "../C-Engine/CPhysics/Transforms.hpp"
#include "../C-Engine/CPhysics/Rigibodys.hpp"

#include "../C-Engine/CRendering/Render.hpp"
#include "../C-Engine/CRendering/Animation.hpp"
#include "../C-Engine/CRendering/Sprite.hpp"
#include "../C-Engine/CRendering/TilesMapping.hpp"

extern "C"
{
#include <fxlib.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "../C-Engine/CExtraLib/MonochromeLib.h"
#include "../C-Engine/CExtraLib/FonctionC.h"
}

class Rigibody;

class Object
{
    public:

    Object();
    ~Object();

    void AffectScript(Script * VScript);
    void AffectEngine(Engine * EV);
    void AffectTag(char * v);

    void Enable();
    void Disable();
    bool IsOnScreen();

    bool CollisionTag(char* v);
    Object * CollisionTagO(char* v);

    //Accesseur

    void  AddRigibody();

    Transforms * GetTransforms();
    Render * GetRender();
    Rigibody * GetRigibody();
    Script * GetScript();
    Engine * GetEngine();

    bool GetEnable();
    char * GetTag();


    private:

    Transforms * OTransforms;
    Render * ORender;
    Rigibody * ORigibody;
    Script * OScript;
    Engine * Conteneur;

    char * tag;
    bool enable;

};

#endif

