#include "../C-Engine/CEngine/Object.hpp"
#include "../C-Engine/CEngine/Engine.hpp"
#include "../C-Engine/CEngine/Script.hpp"

#include "../C-Engine/CPhysics/Transforms.hpp"
#include "../C-Engine/CPhysics/Rigibodys.hpp"

#include "../C-Engine/CRendering/Render.hpp"
#include "../C-Engine/CRendering/Animation.hpp"
#include "../C-Engine/CRendering/Sprite.hpp"
#include "../C-Engine/CRendering/TilesMapping.hpp"

extern "C"
{
#include <fxlib.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "../C-Engine/CExtraLib/input.h"
#include "../C-Engine/CExtraLib/MonochromeLib.h"
#include "../C-Engine/CExtraLib/FonctionC.h"
}


Script::Script()
{
    OConteneur = NULL;
    EConteneur = NULL;
}

void Script::AffectObject(Object * OV)
{
    OConteneur = OV;
}

void Script::AffectEngine(Engine * EV)
{
    if(EV != NULL)EConteneur = EV;
}

void Script::SetXY( double x , double y)
{
    if(OConteneur != NULL)  OConteneur->GetTransforms()->SetXY( x , y);
}

void Script::Move( int x , int y)
{
    if(OConteneur != NULL) OConteneur->GetRigibody()->Move( x , y);
}

void Script::SetIt( int i)
{
    if(OConteneur != NULL) OConteneur->GetRender()->SetIt(i);
}

int Script::GetX()
{
    if(OConteneur != NULL) return OConteneur->GetTransforms()->GetX();
    return 0;
}

int Script::GetY()
{
    if(OConteneur != NULL) return OConteneur->GetTransforms()->GetY();
    return 0;
}

int Script::SizeX()
{
    if(OConteneur != NULL) return OConteneur->GetRender()->GetSizeX();
    return 0;
}

int Script::SizeY()
{
    if(OConteneur != NULL) return OConteneur->GetRender()->GetSizeY();

    return 0;
}

Object * Script::GetObject()
{
    if(OConteneur != NULL) return OConteneur;

    return NULL;
}

Engine * Script::GetEngine()
{
    if(OConteneur != NULL) return OConteneur->GetEngine();
    else if(EConteneur != NULL) return EConteneur;

    return NULL;
}

void Script::Start()
{
}

void Script::Update()
{
}

void Script::UpdateEverySecond()
{
}




