#include "../C-Engine/CEngine/Object.hpp"
#include "../C-Engine/CEngine/Engine.hpp"
#include "../C-Engine/CEngine/Script.hpp"

#include "../C-Engine/CPhysics/Transforms.hpp"
#include "../C-Engine/CPhysics/Rigibodys.hpp"

#include "../C-Engine/CRendering/Render.hpp"
#include "../C-Engine/CRendering/Animation.hpp"
#include "../C-Engine/CRendering/Sprite.hpp"
#include "../C-Engine/CRendering/TilesMapping.hpp"

extern "C"
{
#include <fxlib.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "../C-Engine/CExtraLib/input.h"
#include "../C-Engine/CExtraLib/MonochromeLib.h"
#include "../C-Engine/CExtraLib/FonctionC.h"
}

Map::Map()
{
    this->Tileset = NULL;
    this->map = NULL;
    this->plein = NULL;
    this->hauteur_fenetre = 0;
    this->HAUTEUR_TILE = 0;
    this->largeur_fenetre = 0;
    this->LARGEUR_TILE = 0;
    this->nbtiles_hauteur_monde = 0;
    this->nbtiles_largeur_monde = 0;
    this->xscroll = 0;
    this->yscroll = 0;
}

void Map::AffectEngine( Engine * V)
{
    this->EConteneur = V;
}

void Map::SetMap( const unsigned char * Tile , const unsigned char ** yourmap ,bool * properties, int  taillextile , int tailleytile , int largeurmonde , int hauteurmonde)
{

this->Tileset = Tile;
this->map = (unsigned char **)yourmap;
this->plein = properties;

this->LARGEUR_TILE = taillextile;
this->HAUTEUR_TILE = tailleytile;

this->LARGEUR_DECALAGE_TILE = taillextile / 8;
if(taillextile % 8 != 0)this->LARGEUR_DECALAGE_TILE++;

this->nbtiles_largeur_monde = largeurmonde;
this->nbtiles_hauteur_monde = hauteurmonde;

this->hauteur_fenetre = 63;
this->largeur_fenetre = 127;
}

void Map::SetMap( const unsigned char * Tile , unsigned char ** yourmap ,bool * properties, int  taillextile , int tailleytile , int largeurmonde , int hauteurmonde)
{

this->Tileset = Tile;
this->map = yourmap;
this->plein = properties;

this->LARGEUR_TILE = taillextile;
this->HAUTEUR_TILE = tailleytile;

this->LARGEUR_DECALAGE_TILE = taillextile / 8;
if(taillextile % 8 != 0)this->LARGEUR_DECALAGE_TILE++;

this->nbtiles_largeur_monde = largeurmonde;
this->nbtiles_hauteur_monde = hauteurmonde;

this->hauteur_fenetre = 63;
this->largeur_fenetre = 127;
}

void Map::AfficherMap()
{
	int minx,maxx,miny,maxy;

    int dy =((nbtiles_hauteur_monde ) * HAUTEUR_TILE) - EConteneur->GetScreen()->max.y ;
	minx = EConteneur->GetScreen()->min.x / LARGEUR_TILE ;
	miny =  dy / HAUTEUR_TILE ;

	maxx = largeur_fenetre / LARGEUR_TILE + minx + 2;
	maxy = hauteur_fenetre / HAUTEUR_TILE + miny + 2;

    xscroll = (int)EConteneur->GetScreen()->min.x ;
    yscroll = dy % HAUTEUR_TILE;

    for( int i = minx; i <  maxx; i++)
        {
            for( int j = miny ; j < maxy; j++)
                {
                    if ((i < 0 || i >= nbtiles_largeur_monde || j < 0 ||  j >= nbtiles_hauteur_monde) == false)
                        ML_bmp_or_cl( this->Tileset + HAUTEUR_TILE   * LARGEUR_DECALAGE_TILE * (this->map[j][i] - '0') , (i * LARGEUR_TILE ) - xscroll , ((j - miny) * HAUTEUR_TILE) - yscroll, LARGEUR_TILE , HAUTEUR_TILE);
                }
        }
}

